---
title: TextDecoder
slug: Web/API/TextDecoder
tags:
  - API
  - DOM
  - Encoding
  - Experimental
  - Interface
  - Reference
  - TextDecoder
---
<p>{{APIRef("Encoding API")}}</p>

<p>The <code><strong>TextDecoder</strong></code> interface represents a decoder for a specific text encoding, such as <code>UTF-8</code>, <code>ISO-8859-2</code>, <code>KOI8-R</code>, <code>GBK</code>, etc. A decoder takes a stream of bytes as input and emits a stream of code points.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Examples">Examples</h2>

<h3 id="Representing_text_with_typed_arrays">Representing text with typed arrays</h3>

<p>This example shows how to decode a Chinese/Japanese character <img alt="" src="https://mdn.mozillademos.org/files/16663/2019-05-21_191907.png" style="height: 32px; width: 41px;">, as represented by five different typed arrays: {{jsxref("Uint8Array")}}, {{jsxref("Int8Array")}}, {{jsxref("Uint16Array")}}, {{jsxref("Int16Array")}}, and {{jsxref("Int32Array")}}.</p>

<pre class="brush: js; notranslate">let utf8decoder = new TextDecoder(); // default 'utf-8' or 'utf8'

let u8arr = new Uint8Array([240, 160, 174, 183]);
let i8arr = new Int8Array([-16, -96, -82, -73]);
let u16arr = new Uint16Array([41200, 47022]);
let i16arr = new Int16Array([-24336, -18514]);
let i32arr = new Int32Array([-1213292304]);

console.log(utf8decoder.decode(u8arr));
console.log(utf8decoder.decode(i8arr));
console.log(utf8decoder.decode(u16arr));
console.log(utf8decoder.decode(i16arr));
console.log(utf8decoder.decode(i32arr));
</pre>

<h3 id="Handling_non-UTF8_text">Handling non-UTF8 text</h3>

<p>In this example, we decode the Russian text "Привет, мир!", which means "Hello, world." In our {{domxref("TextDecoder/TextDecoder", "TextDecoder()")}} constructor, we specify the Windows-1251 character encoding, which is appropriate for Cyrillic script.</p>

<pre class="brush: js; notranslate">let win1251decoder = new TextDecoder('windows-1251');
let bytes = new Uint8Array([207, 240, 232, 226, 229, 242, 44, 32, 236, 232, 240, 33]);
console.log(win1251decoder.decode(bytes)); // Привет, мир!
</pre>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{DOMxRef("TextDecoder.TextDecoder", "TextDecoder()")}}</dt>
 <dd>Returns a newly constructed <code>TextDecoder</code> that will generate a code point stream with the decoding method specified in parameters.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>The <code>TextDecoder</code> interface doesn't inherit any properties.</em></p>

<dl>
 <dt>{{DOMxRef("TextDecoder.prototype.encoding")}}{{ReadOnlyInline}}</dt>
 <dd>Is a {{DOMxRef("DOMString")}} containing the name of the decoder, that is a string describing the method the <code>TextDecoder</code> will use.</dd>
 <dt>{{DOMxRef("TextDecoder.prototype.fatal")}}{{ReadOnlyInline}}</dt>
 <dd>Is a {{jsxref('Boolean')}} indicating whether the error mode is fatal.</dd>
 <dt>{{DOMxRef("TextDecoder.prototype.ignoreBOM")}}{{ReadOnlyInline}}</dt>
 <dd>Is a {{jsxref('Boolean')}} indicating whether the byte order marker is ignored.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>TextDecoder</code> interface doesn't inherit any method</em>.</p>

<dl>
 <dt>{{DOMxRef("TextDecoder.prototype.decode()")}}</dt>
 <dd>Returns a {{DOMxRef("DOMString")}} containing the text decoded with the method of the specific <code>TextDecoder</code> object.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Encoding", "#interface-textdecoder", "TextDecoder")}}</td>
   <td>{{Spec2("Encoding")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.TextDecoder")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{DOMxRef("TextEncoder")}} interface describing the inverse operation.</li>
 <li><a href="/en-US/Add-ons/Code_snippets/StringView"><code>StringView</code></a> – a C-like representation of strings based on typed arrays</li>
 <li>A <a href="http://code.google.com/p/stringencoding/">shim</a> allowing to use this interface in browsers that don't support it.</li>
 <li><code><a href="/en-US/docs/Mozilla/Tech/XPCOM/Language_Bindings/Components.utils.importGlobalProperties">Components.utils.importGlobalProperties</a></code></li>
 <li><a href="https://nodejs.org/api/util.html#util_class_util_textdecoder">Node.js supports global export from v11.0.0</a></li>
</ul>
